//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * Waveリーダヘッダ
 * @author Junpee
 */

#ifndef WAVE_READER_H_
#define WAVE_READER_H_

#include <Sound/Reader/SoundReader.h>
#include <Core/InputOutput/FilePath.h>

namespace Lamp{

//------------------------------------------------------------------------------
/**
 * Waveリーダ
 */
class WaveReader : public SoundReader{
public:
	/**
	 * コンストラクタ
	 * @param filePath ファイルパス
	 */
	WaveReader(const FilePath& filePath);

	/**
	 * デストラクタ
	 */
	virtual ~WaveReader();

	//--------------------------------------------------------------------------
	/**
	 * サイズの取得
	 * @return サイズ
	 */
	virtual u_int getSize() const{
		Assert(initialized_);
		return size_;
	}

	/**
	 * サンプル数の取得
	 * @return サンプル数
	 */
	virtual int getSample() const{
		Assert(initialized_);
		return sample_;
	}

	/**
	 * チャンネル数の取得
	 * @return チャンネル数
	 */
	virtual int getChannel() const{
		Assert(initialized_);
		return channel_;
	}

	/**
	 * ビット数の取得
	 * @return ビット数
	 */
	virtual int getBit() const{
		Assert(initialized_);
		return bit_;
	}

	/**
	 * コメントの取得
	 * @return コメント
	 */
	virtual const String& getComment(){
		Assert(initialized_);
		return comment_;
	}

	//--------------------------------------------------------------------------
	/**
	 * 位置の設定
	 * @param cursor 設定する位置
	 */
	virtual void setCursor(u_int cursor);

	/**
	 * 位置の取得
	 * @return 位置
	 */
	virtual u_int getCursor(){ return cursor_; }

	//--------------------------------------------------------------------------
	/**
	 * ヘッダ読み込み
	 * @return 成功すればtrue
	 */
	virtual bool readHeader();

	/**
	 * 読み込み
	 * @param buffer 読み込みバッファ
	 * @param size 読み込みサイズ
	 * @return 読み込んだサイズ。終端なら0、失敗すれば-1
	 */
	virtual int read(void* buffer, u_int size);

	//--------------------------------------------------------------------------
	/**
	 * ファイルがWaveファイルか
	 * @param filePath ファイルパス
	 * @return Waveファイルならtrue
	 */
	static bool isWaveFileName(const FilePath& filePath){
		return filePath.getExtension().equals("wav");
	}

private:
	// ファイルパス
	FilePath filePath_;
	// ファイルハンドル
	HMMIO handle_;
	// RIFFチャンク
	MMCKINFO riffChunk_;
	// データチャンク
	MMCKINFO dataChunk_;
	// コメント
	String comment_;
	// データオフセット
	int dataOffset_;
	// 読み込み位置
	u_int cursor_;
	// サイズ
	u_int size_;
	// サンプル数
	int sample_;
	// チャンネル数
	int channel_;
	// ビット数
	int bit_;
	// 初期化済みフラグ
	bool initialized_;

};

//------------------------------------------------------------------------------
} // End of namespace Lamp
#endif // End of WAVE_READER_H_
//------------------------------------------------------------------------------
